unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, ExtCtrls, Menus, StdCtrls, ComCtrls;

type
  TKPlayer = class(TForm)
    MediaPlayer: TMediaPlayer;
    Display: TPanel;
    MainMenu: TMainMenu;
    MFile: TMenuItem;
    Open_file: TMenuItem;
    Close_file: TMenuItem;
    Exit: TMenuItem;
    Help: TMenuItem;
    About: TMenuItem;
    Author: TMenuItem;
    OpenDialog: TOpenDialog;
    Comments: TLabel;
    Timer1: TTimer;
    filelength: TLabel;
    filepos: TLabel;
    TrackBar: TTrackBar;
    MPlay: TMenuItem;
    MPlaylist: TMenuItem;
    ListBox: TListBox;
    MView: TMenuItem;
    MAddFile: TMenuItem;
    PopupMenu: TPopupMenu;
    AddfileItem: TMenuItem;
    RemoveItem: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Open_fileClick(Sender: TObject);
    procedure KplayerKeyDown(Sender: TObject;var key: word;shift:Tshiftstate);
    procedure DisplayDblClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure Close_fileClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure AboutClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure AuthorClick(Sender: TObject);
    procedure DisplayResize(Sender: TObject);
    procedure MViewClick(Sender: TObject);
    procedure MAddFileClick(Sender: TObject);
    procedure RemoveItemClick(Sender: TObject);
    procedure AddfileItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  KPlayer: TKPlayer;
  i,Count,pcount,plcount: integer;
  coeff,awidth: real;
  r:trect;
implementation




{$R *.dfm}

procedure TKPlayer.FormCreate(Sender: TObject);
begin
 pcount:=10;
 i:=0;
 comments.Caption:='Ready';
 end;

procedure TKPlayer.KplayerKeyDown(Sender: TObject;var Key: word;Shift:tshiftstate);
begin
if  (key=vk_return )and(count=1)and(pcount=1) then
 with KPlayer do
  begin
    showwindow(kplayer.handle,sw_shownormal);
    count:=0;
  end
  else
   begin
   if  (key=vk_return)and(count=0)and(pcount=1)then
 with KPlayer do
  begin

   showwindow(kplayer.handle,sw_maximize);
   count:=1;
  end;
  end;
end;
procedure TKPlayer.Open_fileClick(Sender: TObject);
begin
 if opendialog.execute=true then
  begin
  mediaplayer.filename:=opendialog.FileName;
  try
  listbox.Clear;
  listbox.Items.Add(opendialog.filename);
  listbox.ItemIndex:=0;
  showwindow(kplayer.Handle,sw_shownormal);
  trackbar.position:=0;
  mediaplayer.Open;
  mediaplayer.TimeFormat:=tfMilliseconds;
  trackbar.Enabled:=true;
  Kplayer.Caption:=mediaplayer.FileName+'- Kplayer multimedia';
 //  !!!
 r.top:=mediaplayer.DisplayRect.Top;
 r.Left:=mediaplayer.DisplayRect.Left;
 r.bottom:=mediaplayer.DisplayRect.Bottom;
 r.right:=mediaplayer.DisplayRect.Right;
 display.top:=mediaplayer.DisplayRect.Top;
 display.Left:=mediaplayer.DisplayRect.Left;
 display.height:=mediaplayer.DisplayRect.Bottom;
 display.width:=mediaplayer.DisplayRect.Right;
 if display.width>0 then
 begin
  kplayer.Width:=display.Width;
  kplayer.Height:=display.height+mediaplayer.height+comments.height+trackbar.height+60;
  trackbar.Top:=display.Height+5;
  trackbar.Width:=display.width-trackbar.left-10;
  mediaplayer.Top:=display.Height+trackbar.height+5;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=display.Width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;
  pcount:=1;
 end
 else
 begin
  pcount:=0;
  kplayer.Width:=mediaplayer.Width;
  kplayer.Height:=mediaplayer.Height+comments.Height+trackbar.Height+60;
  trackbar.Top:=5;
  trackbar.Width:=kplayer.Width-2*trackbar.left-10;
  mediaplayer.Top:=trackbar.Height+5;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=kplayer.width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;

 end;
   except
   on EMCIDeviceError do
   showmessage('   !');
  end;
  end;
end;
procedure TKPlayer.DisplayDblClick(Sender: TObject);
begin
 if  (count=1) then
 with KPlayer do
  begin
    showwindow(kplayer.handle,sw_shownormal);
    count:=0;
  end
  else
   begin
   if  (count=0)then
 with KPlayer do
  begin
   showwindow(kplayer.handle,sw_maximize);
   count:=1;
  end;
  end;
end;

procedure TKPlayer.ExitClick(Sender: TObject);
begin
Kplayer.close;
end;

procedure TKPlayer.Close_fileClick(Sender: TObject);
begin
trackbar.Position:=0;
trackbar.Enabled:=false;
mediaplayer.Close;
timer1.Enabled:=false;
mediaplayer.FileName:='';
comments.caption:='Closed';
filelength.Caption:='';
filepos.Caption:='';
listbox.Clear;
{}
showwindow(kplayer.Handle,sw_shownormal);
end;

procedure TKPlayer.Timer1Timer(Sender: TObject);
 function sectodate(tt:integer):string;
    var se,mi,ho :string;
        h,m,s :integer;
    begin
     tt:=tt div 1000;
     h:=tt div 3600;
     m:=(tt mod 3600)div 60;
     s:=(tt mod 3600)mod 60;
     if h<10 then ho:='0'+inttostr(h) else ho:=inttostr(h);
     if m<10 then mi:='0'+inttostr(m) else mi:=inttostr(m);
     if s<10 then se:='0'+inttostr(s) else se:=inttostr(s);
     sectodate:=ho+':'+mi+':'+se;
    end;
//  mediaplayer'
begin
 if mediaplayer.mode=mpPlaying then comments.Caption:='Playing';
 if mediaplayer.mode=mpNotReady then comments.Caption:='NotReady';
 if mediaplayer.mode=mpOpen then comments.Caption:='Opened';
 if mediaplayer.Mode=mpStopped then comments.Caption:='Stopped';
 if mediaplayer.Mode=mpPaused then comments.Caption:='Paused';
 if mediaplayer.Mode=mpSeeking then comments.Caption:='Seeking';
//     
 if mediaplayer.filename<>'' then
  begin
   filelength.Caption:=sectodate(mediaplayer.length);
   filepos.Caption:=sectodate(mediaplayer.position)+'/ ';
   trackbar.max:=mediaplayer.Length;
   trackbar.Position:=mediaplayer.Position;
  end;
//  
 if trackbar.position=mediaplayer.length then
 begin
  if listbox.itemindex+1=listbox.Items.count then
   listbox.itemindex:=-1
  else
   begin
    listbox.ItemIndex:=listbox.ItemIndex+1;
//   
    try
     mediaplayer.FileName:=listbox.Items.Strings[listbox.itemindex];
     showwindow(kplayer.Handle,sw_shownormal);
     trackbar.position:=0;
     mediaplayer.Open;
     mediaplayer.Play;
     mediaplayer.TimeFormat:=tfMilliseconds;
     trackbar.Enabled:=true;
     Kplayer.Caption:=mediaplayer.FileName+'- Kplayer multimedia';
     r.top:=mediaplayer.DisplayRect.Top;
     r.Left:=mediaplayer.DisplayRect.Left;
     r.bottom:=mediaplayer.DisplayRect.Bottom;
     r.right:=mediaplayer.DisplayRect.Right;
     display.top:=mediaplayer.DisplayRect.Top;
     display.Left:=mediaplayer.DisplayRect.Left;
     display.height:=mediaplayer.DisplayRect.Bottom;
     display.width:=mediaplayer.DisplayRect.Right;
     if display.width>0 then
      begin
       kplayer.Width:=display.Width;
       kplayer.Height:=display.height+mediaplayer.height+comments.height+trackbar.height+60;
       trackbar.Top:=display.Height+5;
       trackbar.Width:=display.width-trackbar.left-10;
       mediaplayer.Top:=display.Height+trackbar.height+5;
       comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
       filelength.Top:=comments.Top;
       filepos.Top:=comments.Top;
       comments.Width:=display.Width-filelength.Width-filepos.Width;
       filepos.Left:=comments.width;
       filelength.Left:=comments.Width+filepos.Width;
       if (plcount mod 2)<>0 then
        begin

        end;
       pcount:=1;
      end
     else
      begin
       pcount:=0;
       kplayer.Width:=mediaplayer.Width;
       kplayer.Height:=mediaplayer.Height+comments.Height+trackbar.Height+60;
       trackbar.Top:=5;
       trackbar.Width:=kplayer.Width-2*trackbar.left-10;
       mediaplayer.Top:=trackbar.Height+5;
       comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
       filelength.Top:=comments.Top;
       filepos.Top:=comments.Top;
       comments.Width:=kplayer.width-filelength.Width-filepos.Width;
       filepos.Left:=comments.width;
       filelength.Left:=comments.Width+filepos.Width;


      end;
    except
     on EMCIDeviceError do
     showmessage('   !');
    end;
   end;


 end;
end;

procedure TKPlayer.MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
  var DoDefault: Boolean);
begin
 timer1.Enabled:=true;
end;

procedure TKPlayer.AboutClick(Sender: TObject);
begin
 ShowMessage('    AVI,ASF,MPG    .  .      DVD .');
end;

procedure TKPlayer.TrackBarChange(Sender: TObject);
begin
if trackbar.position>mediaplayer.Position then
 begin
 mediaplayer.position:=trackbar.position;
 mediaplayer.Play;
 end;
if trackbar.position+100<mediaplayer.Position then
 begin
 mediaplayer.position:=trackbar.position;
 mediaplayer.Play;
 end;
end;

procedure TKPlayer.AuthorClick(Sender: TObject);
begin
 ShowMessage(': kosfiz.');
end;

procedure TKPlayer.DisplayResize(Sender: TObject);
begin
if (plcount mod 2)=0 then
begin
if iszoomed(kplayer.handle)=false then
 begin
  display.Height:=r.Bottom;
  display.Width:=r.Right;
  kplayer.Height:=display.Height+comments.Height+trackbar.Height+mediaplayer.Height+60;
  if display.width=0 then
   kplayer.Width:=mediaplayer.Width
  else
  kplayer.Width:=display.Width;
  trackbar.Top:=display.Height+5;
  trackbar.Width:=kplayer.width-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height;
  filepos.Top:=comments.Top;
  filelength.Top:=comments.Top;
  filelength.left:=kplayer.Width-filelength.Width;
  filepos.Left:=filelength.Left-filepos.Width;


  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  mediaplayer.DisplayRect:=rect(0,0,r.Right,r.bottom);
 end;
if iszoomed(kplayer.handle)=true then
 begin
  display.Height:=kplayer.Height-mediaplayer.Height-comments.Height-trackbar.Height-60;
  display.Width:=kplayer.Width;
  trackbar.Top:=display.height+5;
  trackbar.Width:=display.width-trackbar.left-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=display.Width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;
  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  //  mediaplayer'
  coeff:=r.Right/r.bottom;
  mediaplayer.DisplayRect:=rect((display.Width-round(display.Height*coeff))div 2,0,round(display.Height*coeff),display.Height);
 end;
end
else
 begin
if iszoomed(kplayer.handle)=false then
 begin

  display.Height:=r.Bottom;
  display.Width:=r.Right;
  kplayer.Height:=display.Height+comments.Height+trackbar.Height+mediaplayer.Height+160;
  if display.width=0 then
   kplayer.Width:=mediaplayer.Width
  else
  kplayer.Width:=display.Width;
  trackbar.Top:=display.Height+5;
  trackbar.Width:=kplayer.width-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height;
  filepos.Top:=comments.Top;
  filelength.Top:=comments.Top;
  filelength.left:=kplayer.Width-filelength.Width;
  filepos.Left:=filelength.Left-filepos.Width;
  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  mediaplayer.DisplayRect:=rect(0,0,r.Right,r.bottom);
 end;
if iszoomed(kplayer.handle)=true then
 begin

  display.Height:=kplayer.Height-mediaplayer.Height-comments.Height-trackbar.Height-160;
  display.Width:=kplayer.Width;
  trackbar.Top:=display.height+5;
  trackbar.Width:=display.width-trackbar.left-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=display.Width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;
  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  //  mediaplayer'
  coeff:=r.Right/r.bottom;
  mediaplayer.DisplayRect:=rect((display.Width-round(display.Height*coeff))div 2,0,round(display.Height*coeff),display.Height);
 end;
end;
end;
procedure TKPlayer.MViewClick(Sender: TObject);
begin
plcount:=plcount+1;
if (plcount mod 2)<> 0 then
 begin


 //   

  if iszoomed(kplayer.handle)=false then
 begin

  display.Height:=r.Bottom;
  display.Width:=r.Right;
  kplayer.Height:=display.Height+comments.Height+trackbar.Height+mediaplayer.Height+160;
  if display.width=0 then
   kplayer.Width:=mediaplayer.Width
  else
  kplayer.Width:=display.Width;
  trackbar.Top:=display.Height+5;
  trackbar.Width:=kplayer.width-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height;
  filepos.Top:=comments.Top;
  filelength.Top:=comments.Top;
  filelength.left:=kplayer.Width-filelength.Width;
  filepos.Left:=filelength.Left-filepos.Width;


  listbox.Top:=comments.Top+comments.Height;
  //kplayer.Caption:=inttostr(listbox.top);
  //if listbox.visible=true then kplayer.Caption:='true';
  listbox.Width:=display.Width;
  listbox.Height:=100;
  mediaplayer.DisplayRect:=rect(0,0,r.Right,r.bottom);

 end;
if iszoomed(kplayer.handle)=true then
 begin

  listbox.Height:=100;
  display.Height:=kplayer.Height-mediaplayer.Height-comments.Height-trackbar.Height-160;
  display.Width:=kplayer.Width;
  trackbar.Top:=display.height+5;
  trackbar.Width:=display.width-trackbar.left-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=display.Width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;
  listbox.Top:=kplayer.Height-listbox.height+comments.Height;
  listbox.Left:=0;
  listbox.Width:=display.Width;
  //  mediaplayer'
  coeff:=r.Right/r.bottom;
  mediaplayer.DisplayRect:=rect((display.Width-round(display.Height*coeff))div 2,0,round(display.Height*coeff),display.Height);

 end;
 end
else
 begin

 if iszoomed(kplayer.handle)=false then
 begin


  display.Height:=r.Bottom;
  display.Width:=r.Right;
  kplayer.Height:=display.Height+comments.Height+trackbar.Height+mediaplayer.Height+60;
  if display.width=0 then
   kplayer.Width:=mediaplayer.Width
  else
  kplayer.Width:=display.Width;
  trackbar.Top:=display.Height+5;
  trackbar.Width:=kplayer.width-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height;
  filepos.Top:=comments.Top;
  filelength.Top:=comments.Top;
  filelength.left:=kplayer.Width-filelength.Width;
  filepos.Left:=filelength.Left-filepos.Width;
  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  mediaplayer.DisplayRect:=rect(0,0,r.Right,r.bottom);
 end;
if iszoomed(kplayer.handle)=true then
 begin
  display.Height:=kplayer.Height-mediaplayer.Height-comments.Height-trackbar.Height-60;
  display.Width:=kplayer.Width;
  trackbar.Top:=display.height+5;
  trackbar.Width:=display.width-trackbar.left-10;
  mediaplayer.Top:=trackbar.Top+trackbar.Height;
  comments.Top:=mediaplayer.Top+mediaplayer.Height+5;
  filelength.Top:=comments.Top;
  filepos.Top:=comments.Top;
  comments.Width:=display.Width-filelength.Width-filepos.Width;
  filepos.Left:=comments.width;
  filelength.Left:=comments.Width+filepos.Width;
  listbox.Top:=comments.Top+comments.Height;
  listbox.Width:=display.Width;
  listbox.Height:=100;
  //  mediaplayer'
  coeff:=r.Right/r.bottom;
  mediaplayer.DisplayRect:=rect((display.Width-round(display.Height*coeff))div 2,0,round(display.Height*coeff),display.Height);
 end;
 end;
end;

procedure TKPlayer.MAddFileClick(Sender: TObject);
begin
 if opendialog.execute=true then
  begin
  mediaplayer.filename:=opendialog.FileName;
  listbox.Items.Add(opendialog.filename);
  end;
end;

procedure TKPlayer.RemoveItemClick(Sender: TObject);
begin
listbox.Items.Delete(listbox.itemindex);
end;

procedure TKPlayer.AddfileItemClick(Sender: TObject);
begin
if opendialog.execute=true then
 listbox.Items.add(opendialog.FileName);
end;

end.
